/*
 * Booking dates form generator (simple version) - main routines
 * Copyright (C) 1999 Open World Ltd
 * Written by Shevek <shevek@anarres.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "library.h"
#include "vector.h"
#include "smalloc.h"
#include "hash.h"
#include "cgi.h"

#define DIR_TEMPLATE DIR_BASE "/scripts/bookingdates/company/"
/* #define DIR_TEMPLATE "/mnt/share/scripts/bookingdates/company/" */

void template_parse(rope_t *pathstr);

void
invoke(void)
{
	hash_t		*cgihash;
	rope_t		*pathstr;
	char		*company;
	char		*template;
	static char	 dir[5];

	cgihash = cgi_hash_new();

	company = hash_get(cgihash, "Company");
	if (!company)
		cgi_fatal("No value for 'Company' in CGI hash table");
	
	template = hash_get(cgihash, "TemplateTitle");
	if (!template)
		cgi_fatal("No value for 'TemplateTitle in CGI hash table");

	strcpy(dir, "X/");
	dir[0] = template[0];

	pathstr = rope_new(DIR_TEMPLATE);
	rope_add(pathstr, company);
	rope_add(pathstr, "/templates/");
	rope_add(pathstr, dir);
	rope_add(pathstr, template);
	rope_add(pathstr, ".tpt");

	printf("Content-type: text/html\r\n\r\n");

	template_parse(pathstr);
}
