#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <syslog.h>

#define BUFFER_SIZE 64

int main( int argc, char *argv[] ) {
	int nbytes;
	char line[ 512 ];
	struct sockaddr_in from;
	int fromlen = sizeof( from );

	openlog( "recvnote", LOG_PID, LOG_DAEMON );

	if ( argc != 2 ) {
		syslog( LOG_ERR, "Usage: %s <logfile>\n", argv[ 0 ] );
		exit( EXIT_FAILURE );
	}

	nbytes =
		recvfrom(
				fileno( stdin ),
				line, sizeof( line ) - 1,
				0,
				&from, &fromlen
		);

	if ( nbytes < 0 ) {
		syslog( LOG_ERR, "No bytes received\n" );
		exit( EXIT_FAILURE );
	}

	line[ nbytes ] = '\0';
	syslog( LOG_INFO, "The message was '%s'\n", line );

	return EXIT_SUCCESS;
}
