/*
 * C utility library
 * Copyright (C) 1999 Open World Ltd
 * Written by Shevek <shevek@anarres.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "smalloc.h"
#include "cgi.h"
#include "log.h"

void *
smalloc(size_t size)
{
	void	*ret = malloc(size);
	if (!ret) {
		fprintf(stderr, "smalloc: Could not malloc %d bytes\n", size);
		log("cgisys", PRI_ALERT, "Could not malloc %d bytes", size);
		exit(0);
	}
	return ret;
}

void *
srealloc(void *ptr, size_t size)
{
	void	*ret = realloc(ptr, size);
	if (!ret) {
		fprintf(stderr, "smalloc: Could not realloc %d bytes\n", size);
		log("cgisys", PRI_ALERT, "Could not realloc %d bytes", size);
		exit(0);
	}
	return ret;
}

char *
sstrdup(char *str)
{
	char	*out;
	out = strdup(str);
	if (!out) {
		fprintf(stderr, "smalloc: Could not duplicate %s\n", str);
		log("cgisys", PRI_ALERT, "Could not duplicate %s", str);
		exit(0);
	}
	return out;
}
